#!/bin/sh

# Build libogg for OGG unpacking.
if [ ! -f /tmp/build/libogg.a ]; then
	mkdir -p /tmp/build/libogg
	for FILE in libraries/libogg-1.3.5/src/*.c; do
		NAME="$(basename "$FILE")"
		gcc -O2 -c "$FILE" -o "/tmp/build/libogg/$NAME.o" || exit 1
	done
	ar rcs /tmp/build/libogg.a /tmp/build/libogg/*.o || exit 1
fi

# Build libvorbis for OGG decoding.
if [ ! -f /tmp/build/libvorbis.a ]; then
	mkdir -p /tmp/build/libvorbis
	for FILE in libraries/libvorbis-1.3.7/lib/*.c; do
		NAME="$(basename "$FILE")"
		[ "$NAME" = psytune.c ] && continue
		gcc -O2 -I libraries/libogg-1.3.5/include -I libraries/libvorbis-1.3.7/lib -c "$FILE" -o "/tmp/build/libvorbis/$NAME.o" || exit 1
	done
	ar rcs /tmp/build/libvorbis.a /tmp/build/libvorbis/*.o || exit 1
fi

# Build KISS FFT for audio analsysis.
if [ ! -f /tmp/build/kissfft.a ]; then
	mkdir -p /tmp/build/kissfft
	for FILE in libraries/kissfft-131.1.0/*.c; do
		NAME="$(basename "$FILE")"
		gcc -O2 -I libraries/kissfft-131.1.0 -DFIXED_POINT=16 -c "$FILE" -o "/tmp/build/kissfft/$NAME.o" || exit 1
	done
	ar rcs /tmp/build/kissfft.a /tmp/build/kissfft/*.o || exit 1
fi

gcc -Wall -Wextra -g -I libraries/libvorbis-1.3.7/include -I libraries/kissfft-131.1.0 src/*.c /tmp/build/libvorbis.a /tmp/build/libogg.a /tmp/build/kissfft.a -o /tmp/build/main -lSDL2 -lm || exit 1
